VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "OutlookAgentClass"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Implements AgentInterf

Dim WithEvents mAgentFactoryLocal As Agent
Attribute mAgentFactoryLocal.VB_VarHelpID = -1
Dim mAgent As IAgentCtlCharacterEx
Attribute mAgent.VB_VarHelpID = -1

Friend Sub clone_internal()
  Set mAgentFactoryLocal = New Agent
' TODO: Seleccionar idioma de acuerdo con SAPI
'  mAgentFactoryLocal.SpeechInput.Engine = "{c5334e50-6dac-11d2-A417-000629F00D75}"
  mAgentFactoryLocal.Characters.Load ("default")
  Set mAgent = mAgentFactoryLocal.Characters("default")
'  mAgent.TTSModeID = "{bf5ead67-9f65-11cf-8FC8-0020AF14F271}"
End Sub

Property Get theAgent() As IAgentCtlCharacterEx
Attribute theAgent.VB_UserMemId = 0
  Set theAgent = selectAgent
End Property

Private Function selectAgentFactory() As Agent
  If mAgentFactoryLocal Is Nothing Then
    Set selectAgentFactory = mAgentFactoryGlobal
  Else
    Set selectAgentFactory = mAgentFactoryLocal
  End If
End Function

Private Function selectAgent() As IAgentCtlCharacterEx
  If mAgent Is Nothing Then
    Set selectAgent = mAgentGlobal
  Else
    Set selectAgent = mAgent
  End If
End Function

Private Function AgentInterf_clone() As OutlookAssistantInterf.AgentInterf
  Dim theCopy As New OutlookAgentClass
  theCopy.clone_internal
  Set AgentInterf_clone = theCopy
End Function

Private Property Get AgentInterf_directAgent() As AgentObjects.IAgentCtlCharacterEx
  Set AgentInterf_directAgent = selectAgent
End Property

Private Property Get AgentInterf_directAgentConnector() As Agent
  Set AgentInterf_directAgentConnector = selectAgentFactory
End Property

Private Sub AgentInterf_init()
' No necesitamos hacer nada aqu
End Sub

Private Sub AgentInterf_Play(Anim As String, Optional wait As Boolean = False)
  selectAgent.Play (Anim)
End Sub

Private Sub AgentInterf_Speak(txt As String)
  selectAgent.Speak (txt)
End Sub

Private Sub AgentInterf_StopReq()
  selectAgent.StopAll
End Sub

Private Property Let AgentInterf_Visible(ByVal visible As Boolean)
  If visible Then
    selectAgent.Show
  Else
    selectAgent.Hide
  End If
End Property

Private Property Get AgentInterf_Visible() As Boolean
  AgentInterf_Visible = selectAgent.visible
End Property

Private Sub Class_Initialize()
  If mAgentFactoryGlobal Is Nothing Then
    Set mAgentFactoryGlobal = New Agent
    '
    Set mAgentFactoryLocal = mAgentFactoryGlobal
    mAgentFactoryLocal.SpeechInput.Engine = "{c5334e50-6dac-11d2-A417-000629F00D75}"
    mAgentFactoryLocal.Characters.Load ("default")
    Set mAgentGlobal = mAgentFactoryGlobal.Characters("default")
    mAgentGlobal.TTSModeID = "{bf5ead67-9f65-11cf-8FC8-0020AF14F271}"
  End If
  glngUseCount = glngUseCount + 1
End Sub

Private Sub Class_Terminate()
  Set mAgentFactoryLocal = Nothing
  glngUseCount = glngUseCount - 1
  If glngUseCount = 0 Then
    Set mAgentFactoryGlobal = Nothing
    'Set mAgentFactory = Nothing
  End If
End Sub
