VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Rule"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable(s) to hold property value(s)
Public name As String
Public Folder As String
Public Desc As String
'Public num As Integer
'Public Argumento As String
Public Activa As Boolean

'Private mvarTipo As String 'local copy
Private condiciones As New Collection
Private acciones As New Collection

Public Function Evaluate(Msg As Object) As Boolean
  Dim c As Condition
  If Activa = False Then
    Evaluate = False
  Else
    Evaluate = True
    For Each c In condiciones
      If c.Evaluate(Msg) = False Then
        Evaluate = False
        Exit For
      End If
    Next
    Set c = Nothing
  End If
End Function

Public Sub aplicar(Msg As Object)
  Dim a As Action
  For Each a In acciones
    a.aplicar Msg
    DoEvents
  Next
  Set a = Nothing
End Sub
Public Sub Load(m As Outlook.PostItem)
  Dim m1 As MAPI.Message
  Dim att As MAPI.Attachment
  Dim att2 As Outlook.PostItem
  name = m.Subject
  Set m1 = MsgOutlook2MAPI(m)
  For Each att In m1.Attachments
    'Set att = a1
    Set att2 = AttMAPI2Outlook(att)
    Select Case att2.MessageClass
    Case "IPM.Post.Ruler.Condition"
      Dim cond As New Condition
      cond.Load att2
      condiciones.Add cond
    Case "IPM.Post.Ruler.Action"
      Dim act As New Action
      act.Load att2
      acciones.Add act

    Case Else
      MsgBox "Clase de anexo desconocida:" & att2.MessageClass & " en regla " & name
    End Select
  Next
  ' TODO: Activa
  Activa = True
End Sub
' Versin antigua, con todas las reglas en el registro. Eliminar
Private Sub LoadObsoleto(iFolder As String, iName As String)
  Dim s As String
  Dim auxStr As String
'  Dim auxNombre As String
  Dim auxCond As String
  Dim auxAction As String
  
  ' Establecemos propiedades a partir de parmetros
  name = iName
  Folder = iFolder
  ' Leemos la condicin desde el registro
  s = GetSetting(app.Title, "Rules_" & iFolder, "rule_" & iName, "||")
  ' podemos tener un primer carcter que indica que la propiedad est desactivada
  If Left(s, 1) = "*" Then
    s = Mid(s, 2)
    Activa = False
  Else
    Activa = True
  End If
  ' Separando el nombre, condiciones y acciones, que tienen "|" entre ellos
  split s, "|", auxCond, auxStr
  split auxStr, "|", auxAction, Desc
  ' En el tipo, podemos tener un primer carcter que indica que la propiedad est desactivada
  'loadAllConditions auxCond
  load_cond_listObsoleto condiciones, iFolder, auxCond
  
  loadAllActions auxAction
End Sub

'Private Sub loadAllConditions(strc As String)
' TODO: c puede contener varias condiciones, separadas por espacios
' separarlas, hacer un bucle, y aadirlas todas
'Dim c As New Condition
'c.Load Folder, strc
'condiciones.Add c
'End Sub

Private Sub loadAllActions(stra As String)
  ' TODO: a puede contener varias acciones, separadas por espacios
  ' separarlas, hacer un bucle, y aadirlas todas
  Dim a As New Action
  a.LoadObsoleto Folder, stra
  acciones.Add a
End Sub

Public Sub SaveObsoleto(Folder As String)
  ' TODO
  Dim s As String
  Dim c As Condition
  
  
  For Each c In condiciones
    s = s & c.name & " "
  Next
  ' TODO: acciones
  s = s & "|<acciones>"
  s = s & Desc
  ' "*" indicador de inactivo delante de la cadena
  If Activa = False Then
    s = "*" & s
  End If
  SaveSetting app.Title, "Rules_" & Folder, "Rule_" & name, s
End Sub





