Attribute VB_Name = "OutlookMAPIModule"
Option Explicit

Global MAPIApp As MAPI.Session
Global MAPIID2OutlookMsg As New Collection

Public Sub initMAPI()
  Set MAPIApp = New MAPI.Session
  MAPIApp.Logon , , , False
End Sub

Public Function MsgOutlook2MAPI(m As Outlook.PostItem) As MAPI.Message
  Set MsgOutlook2MAPI = MAPIApp.GetMessage(m.EntryID)
End Function

' La siguiente funcin toma un documento anexo, que sea un elemento de Outlook o un acceso directo a uno,
' Y devuelve el original del mensaje
' Se basa en que la propiedad 14 contiene la parte central del EntryID del mensaje original
' En el mensaje original, los 8 primeros caracteres son ceros, y los caracteres de la parte final, van variando,
' y no se cmo se podran obtener.
' TODO: Buscar una forma mas limpia y segura de hacer esto
Public Function AttMAPI2Outlook(att As MAPI.Attachment) As Outlook.PostItem
  'Debug.Print att.Position, att.Fields(14)
  'Set AttMAPI2Outlook = MAPIID2OutlookMsg(att.Fields(14))
  Set AttMAPI2Outlook = MAPIID2OutlookMsg(att.Fields(2))
End Function
' Esta rutina construye una "tabla hash" para acceder a los datos
Public Sub prepareIDconversion(f As Outlook.MAPIFolder)
  Dim Msg As Outlook.PostItem
  Dim id As String
  On Error Resume Next ' Puede haber duplicados
  For Each Msg In f.Items
'    id = Mid(Msg.EntryID, 9, 32)
    id = Msg.Subject
    'Debug.Print Msg.EntryID, id, Msg.Subject
    MAPIID2OutlookMsg.Add Msg, id
    If Err Then
      MsgBox Msg.Subject, , "Elemento Repetido"
      Err.Clear
    End If
  Next
End Sub

