VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Action"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public name As String
Public Argumento As String
Public Activa As Boolean

'local variable(s) to hold property value(s)
Private mvarTipo As String 'local copy
Private folderArgumento As Outlook.mapiFolder

Public Function YaAplicado(Msg As Object) As Boolean
  Dim m As Outlook.MailItem
  Select Case mvarTipo
  Case "Para"
    YaAplicado = checkList(Msg.Recipients, Argumento)
  Case "cc"
    YaAplicado = checkList(Msg.CC, Argumento)
  Case "bcc"
    YaAplicado = checkStr(Msg.BCC, Argumento)
  Case "Categoria"
    YaAplicado = checkStr(Msg.Categories, Argumento)
  Case "Move2Folder"
    YaAplicado = Msg.Parent.EntryID = folderArgumento.EntryID
  Case "Copy2Folder"
    YaAplicado = Msg.Parent.EntryID = folderArgumento.EntryID
  End Select
End Function

Public Function aplicar(Msg As Object)
  Dim m As Outlook.MailItem
  If YaAplicado(Msg) = False Then
    Select Case mvarTipo
    Case "Para"
      Msg.Recipients.Add Argumento
      Msg.Save
    Case "cc"
      Msg.CC.Add Argumento
      Msg.Save
    Case "bcc"
      Msg.BCC.Add Argumento
      Msg.Save
    Case "Categoria"
      Msg.Categories = Msg.Categories & ";" & Argumento
      Msg.Save
    Case "Move2Folder"
      Msg.Move folderArgumento
    Case "Copy2Folder"
      Msg.Copy folderArgumento
    End Select
  Else
    MsgBox name & " " & Msg.Subject, , "Regla ya aplicada"
  End If
End Function
Public Sub Load(act As Outlook.PostItem)
  name = act.Subject
  Argumento = act.Body
  Tipo = act.UserProperties("Accion")
  ' TODO: Activa
  Activa = True
End Sub
Public Sub LoadObsoleto(Folder As String, iName As String)
  Dim s As String
  Dim auxTipo As String
  ' Establecemos propiedades a partir de parmetros
  name = iName
  ' Leemos la condicin desde el registro
  s = GetSetting(app.Title, "Rules_" & Folder, "Action_" & iName, "*NOP|")
  ' podemos tener un primer carcter que indica que la propiedad est desactivada
  If Left(s, 1) = "*" Then
    s = Mid(s, 2)
    Activa = False
  Else
    Activa = True
  End If
  ' separamos sus campos, tipo|Argumento
  split s, "|", auxTipo, Argumento
  Tipo = auxTipo
End Sub

Public Sub Save(Folder As String)
  Dim s As String
  
  s = Tipo & "|" & Argumento
  ' "*" indicador de inactivo delante de la cadena
  If Activa = False Then
    s = "*" & s
  End If
  SaveSetting app.Title, "Rules_" & Folder, "Action_" & name, s
End Sub


Public Property Let Tipo(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Tipo = 5
  On Error Resume Next
  Select Case vData
    Case "NOP"
    Case "Para"
    Case "cc"
    Case "bcc"
    Case "Categoria"
    Case "Move2Folder"
      Set folderArgumento = OpenMAPIFolder(Argumento)
      If Err.Number = -2147221233 Then
        MsgBox Argumento, , Err.Description
        Err = 0
        Activa = False
      End If
    Case "Copy2Folder"
      Set folderArgumento = OpenMAPIFolder(Argumento)
      If Err.Number = -2147221233 Then
        MsgBox Argumento, , Err.Description
        Err = 0
        Activa = False
      End If
    Case Else
      ' No ejecutar
      MsgBox "No se actualiza tipo a" & vData
      GoTo salir
  End Select
  mvarTipo = vData
salir:
End Property


Public Property Get Tipo() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Tipo
    Tipo = mvarTipo
End Property

