VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "OutlookRulerClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Clase para automatizacin OLE de Outlook Ruler.\r\nOutlook Ruler es parte de Outlook Assistant.\r\n"
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Implements SubsystemInterf

Public AskProfile As Boolean

Private fMainForm As InboxFrm

Dim WithEvents merlinEvents As Agent
Attribute merlinEvents.VB_VarHelpID = -1

'local variable(s) to hold property value(s)
'Private mvarActor As ActorInterfaceClass  'local copy

'Public Property Get Actor() As ActorInterfaceClass

'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Actor
'    Set Actor = mvarActor
'End Property


Public Sub init()
  With frmSplash
    .Show
    .Refresh
  End With
  privSplashMsg getString(100) ' "Conectando con Outlook..."
  initOutlook
  privSplashMsg getString(101) ' "Conectando con MAPI..."
  Debug.Print Command
  If AskProfile Then
    Set MAPIApp = New MAPI.Session
    'privSplashMsg "Conectando con MAPI(2)..."
    MAPIApp.Logon
    'privSplashMsg "Conectando con MAPI(3)..."
  Else
    ' Normalmente, MAPI seleccionar el mismo perfil que Outlook
    initMAPI
  End If

'  test
  privSplashMsg getString(102) '"Preparando ventana principal..."
  Set fMainForm = New InboxFrm
  Load fMainForm
  Set fMainForm.menu = fMainForm.mnuContextual
  privSplashMsg getString(103) '"Leyendo mensajes..."
  fMainForm.busca_mensajes_carpeta
  privSplashMsg getString(104) '"Leyendo reglas..."
  Load_reglas
  'Load frmRules
  'init_agent
  init_commands
  fMainForm.Show
  Unload frmSplash
  
  If Merlin Is Nothing Then
    Set Merlin = CreateObject("OutlookDummyAgent.AgentDummyClass")
  End If
  'fMainForm.Show
End Sub

Public Sub SplashMsg(ByVal vData As String)
Attribute SplashMsg.VB_Description = "Muestra un mensaje en la pantalla de Splash durante la carga de la aplicacin."
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.SplashMsg = 5
  privSplashMsg (vData)
End Sub

Public Sub componerNuevoElemento()
  Dim f As New EditItemForm
  f.Show
End Sub

Public Sub busca_nuevo_correo()
  InboxFrm.busca_nuevo_correo
End Sub

Public Sub lee_mensajes_activos()
  'Dim m As CommandBars
  'Set m = olApp.Application.ActiveInspector.CommandBars
  'Debug.Print m.Count

  InboxFrm.lee_mensajes_activos
End Sub

Public Sub busca_mensajes_carpeta()
  InboxFrm.busca_mensajes_carpeta
End Sub

'Public Sub fija_menu(mnu As Object)
'  Set fMainForm.menu = mnu
'End Sub



Private Sub privSplashMsg(Msg As String)
  With frmSplash
    .Status = Msg
    .Status.Refresh
  End With
End Sub

Private Sub Class_Terminate()
  Unload fMainForm
End Sub

'Private Sub SubsystemInterf_definirActor(a As OutlookAssistantInterf.AgentInterf)
'  Set Merlin = a
'End Sub

'Public Property Get SubsystemInterf_Name() As String
'  SubsystemInterf_Name = "Outlook Ruler"
'End Property

'Public Property Get SubsystemInterf_Visible() As Boolean
'  SubsystemInterf_Visible = fMainForm.Visible
'End Property

'Public Property Let SubsystemInterf_Visible(ByVal v As Boolean)
'  fMainForm.Visible = v
'End Property

Private Sub SubsystemInterf_definirActor(a As OutlookAssistantInterf.AgentInterf)
  If Not a Is Nothing Then
    Set Merlin = a.Clone
    Set merlinEvents = Merlin.directAgentConnector
  Else
    Set Merlin = Nothing
    Set merlinEvents = Nothing
  End If
End Sub

Private Sub SubsystemInterf_init()
  init
End Sub

Private Property Get SubsystemInterf_Name() As String
  SubsystemInterf_Name = app.ProductName
End Property

Private Property Get SubsystemInterf_Visible() As Boolean

End Property

Private Property Let SubsystemInterf_Visible(ByVal RHS As Boolean)
End Property

Private Sub init_commands()
  privSplashMsg getString(105) ' "Conectando con Agente..."
  If Not Merlin Is Nothing Then
    If Not Merlin.directAgent Is Nothing Then
      With Merlin.directAgent.Commands
        ' Encabezado de los comandos
        .Caption = getString(1000) '"Outlook Ruler"
        .Voice = getString(1001) '"ruler"
        .VoiceCaption = getString(1000)
        .Visible = True
        '
        .Add "CheckMail", getString(1004), getString(1005), True, True
        .Add "MensajeActivo", getString(1006), getString(1007), True, True
        .Add "Carpeta", getString(1008), getString(1009), True, True
        .Add "Componer", getString(1010), getString(1011), True, True
        '.Add "Ventana", "Ver Ventana Control", "control", True, True
        '
        .Add "Stop", getString(1002), getString(1003), True, True ' Parar comando actual
      End With
    End If
  End If
End Sub

Private Sub merlinEvents_Command(ByVal c As Object)
  Select Case c.name
  Case "CheckMail"
    fMainForm.busca_nuevo_correo
  Case "MensajeActivo"
    fMainForm.lee_mensajes_activos
  Case "Carpeta"
    fMainForm.busca_mensajes_carpeta
  Case "Componer"
    componerNuevoElemento
  Case "Stop"
    Merlin.StopReq
  Case Else
    MsgBox "comando desconocido " & c.name, , "Outlook Ruler"
  End Select
End Sub

